/**
 * Die Klasse BoulderDash erzeugt das ursprngliche Spielfeld und beinhaltet alles andere des Spiels.
 * Gestartet wird das Spiel entweder per game-Methode, welche die Spielzge als int-Werte 0-4
 * erwartet (beginnend mit hoch gegen den Uhrzeigersinn. 4 ist stehen bleiben.) oder per main-
 * Methode, welche die Eingabe als wasd-Steuerung + x zum Warten erwartet.
 * Sie verfgt ber einen Testmodus, welcher den Level aus der Vorlesung aufruft und nur die im
 * bungszettel verlangten Verhaltensweisen und Regeln kennt.
 * 
 * Nhere Informationen in der Readme.txt
 * 
 * @author (Marc A. Modrow) 
 * @version (9.02.08)
 */
public class BoulderDashBackEnd{

    /** field beinhaltet das Feld, wie es als String-Array vorgegeben wurde.*/
    String[] field;
    
    /** fieldChar ist zunchst field in ein 2-dimensionales Character-Array. Spter werden hier 
     *  auch die Aktualisierungen des Feldes gespeichert und abgerufen.
     */
    char[][] fieldChar;
    
    /** fieldMob ist quivalent zu fieldChar, speichert aber nicht die Buchstaben, sondern ihre
     *  ihnen zugeordneten Objekte.
     */
    MOB[][] fieldMob;
    
    /** Gibt es keinen Spieler darf das Spiel nicht mehr auf Richtungstasten reagieren, sondern nur auf
     *  Escape zum neu starten. Darum gibt es playerExists, was bei jeder Exeption auf false gesetzt wird
     *  und erst beim reset wieder auf true.
     */
    boolean playerExists;
    
    /** In dieser Variablen wird die Anzahl der verbeibenden Schtze gespeichert.*/
    int treasures;
    String message = null;
    /** Der Konstruktor von BoulderDash erzeugt das ursprngliche Feld und bertrgt es in fieldChar. Auerdem 
     *  erzeugt es fr jedes S, U und O auf dem Spielfeld ein entsprechendes Objekt und speichert es in fieldMob.
     *  Des Weiteren erzeugt der Konstruktor ein Fenster, das zur Echtzeitsteuerung ntig ist und weist ihm einen 
     *  Keylistener zu. Am Schluss wird das Startspielfeld in der Konsole ausgegeben.
     */
    BoulderDashBackEnd(){
        // Spielfeld-Eingabe.
        String[] field = {
            "MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM", 
            "MOE           O!M   UMEOOOO! S  A", 
            "M!E    U   E  EMM    MOOOOOOEEEEM", 
            "M E       E E   M    MEEEEEEEMMMM", 
            "M E             M  E   EE U  EEEM", 
            "M  E E      E   M   EE         !M", 
            "MEE         E  OE   M E E  E    M", 
            "MMMMMMMMMMM     M     E         M", 
            "MEE EE  E   U EEE     EU  E     M", 
            "M   E E        MEOE       E   EUM", 
            "M U EEE    E   MEO   E  E       M", 
            "M   E E        MEOE       E     M", 
            "M! EE E U     EM!E E E! EE    E M", 
            "MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM"};
        this.field = field;
        char[][] fieldChar = new char[field.length][field[0].length()];
        this.fieldChar = fieldChar;
        MOB[][] fieldMob = new MOB[field.length][field[0].length()];
        this.fieldMob = fieldMob;
        // Kopieren von field nach fieldChar.
        generateNewField();
        this.playerExists = true;
        // Start-Spielfeld ausgeben.
    }
    /** Die Methode step lsst alle Objekte ihre Bewegung fr einen Spielzug machen. Ist in der in der Doppelschleife
     *  angesprochene Element des Spielfelds ein 'S' also Spieler, so wird zunchst die mitgelieferte 
     *  Bewegungsrichtung als neue Bewegungsrichtung gespeichert. Zuletzt wird noch das Spielfeld erneut
     *  ausgegeben.
     *  @param dir ist die Bewegungsrichtung, die der Spieler im zu generierenden Spielzug einschlgt.
     */
    void step(int dir) throws Exception{
        // Mit 2 Schleifen wird das Chararray abgelaufen.
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < field[i].length(); j++){
                // Per switch wird getestet, ob das aktuelle Feld ein Objekt reprsentiert und ggf. 
                // wird das Objekt erstellt und im MOB-Array abgespeichert.
                // Der boolean moved und seine set-Methode stellen sicher, dass sich jedes Objekt
                // nur ein mal pro Zug bewegt.
                switch(fieldChar[i][j]){
                    case 'S': fieldMob[i][j].setDir(dir);
                    if (!fieldMob[i][j].moved){
                        fieldMob[i][j].setMoved();
                        fieldMob[i][j].update();
                    }
                    default: break;
                }
            }
        }
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < field[i].length(); j++){
                // Per switch wird getestet, ob das aktuelle Feld ein Objekt reprsentiert und ggf. 
                // wird das Objekt erstellt und im MOB-Array abgespeichert.
                // Der boolean moved und seine set-Methode stellen sicher, dass sich jedes Objekt
                // nur ein mal pro Zug bewegt.
                switch(fieldChar[i][j]){
                    case 'U':if (!fieldMob[i][j].moved){
                        fieldMob[i][j].setMoved();
                        fieldMob[i][j].update();
                    }
                    break;
                    case 'O': if (!fieldMob[i][j].moved){
                        fieldMob[i][j].setMoved();
                        fieldMob[i][j].update();
                    }
                    break;
                    default: break;
                }
            }
        }
        // Ist alles bewegt werden alle Obejekte als noch nicht bewegt markiert.
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < field[i].length(); j++){
                if(fieldMob[i][j] != null){
                    fieldMob[i][j].setNotMoved();
                }
            }
        }
        // Am Ende jedes Spielzuges wird das Spielfeld ausgegeben.
        print();
    }
    
    /** Die Methode print gibt das Spielfeld in der Konsole aus.*/
    protected void print(){
        // Mit 2 Schleifen wird das Chararray abgelaufen. Dieses Konstrukt wird 
        // uns noch fter begegnen, ich kommentiere es fortan nicht mehr extra.
        if(treasures>0){
            message = "Noch " + treasures + " Sch\u00e4tze verbleibend";
        }
        else{
            message = "Alle Sch\u00e4tze eingesammelt. Gehe zum Ausgang!";
        }
    }
    
    /** Die Methode reset startet das Spiel neu.*/
    void reset(){
        treasures = 0;
        generateNewField();        
        print();
        playerExists = true;
    }
    
    /** Die Methode generateNewField erzeugt ein neues Spielfeld incl aller Objekte aus dem gegebenen field.
     * Auerdem werden die Schtze gezhlt.
     */
    void generateNewField(){
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < field[i].length(); j++){
                fieldChar[i][j] = field[i].charAt(j);
            }
        }
        // MOBs erzeugen um das Spielfeld zu fllen und nach fieldMob speichern.
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < fieldChar[i].length; j++){
                // Dieser switch generiert Objekte passend zu den Zeichen, die sie symbolisieren.
                switch(fieldChar[i][j]){
                    case 'U': fieldMob[i][j] = new Monster(i,j);
                        break;
                    case 'O': fieldMob[i][j] = new Stone(i,j);
                        break;
                    case 'S': fieldMob[i][j] = new Player(i,j);
                        break;
                    default: fieldMob[i][j] = null;
                        break;
                }
            }
        }
        // Schtze zhlen.
        for(int i = 0; i < field.length; i++){
            for(int j = 0; j < fieldChar[i].length; j++){
                if (fieldChar[i][j] =='!'){
                    treasures +=1;
                }
            }
        }
        print();
    }
            
    /**
     * Die abstrakte lokale Klasse MOB ist die Basisklasse aller beweglichen Elemente (Movable Objects).
     * Sie gibt vor, dass eine parameterloses update-Methode und eine int-erwartende setDir-Methode in 
     * abgeleiteten Klassen implementiert werden mssen.
     */
    abstract public class MOB {
        
        /** Jedes MOB hat eine X-Position auf dem Spielfeld und kennt sie.*/
        int posX;
        
        /** Jedes MOB hat eine Y-Position auf dem Spielfeld und kennt sie.*/
        int posY;
        
        /** Das MOB wei, ob es diese Runde bereits bewegt wurde.*/
        boolean moved;
        
        /** Das MOB kennt zustzlich zur Positionierung noch eine Bewegungsrichtung.*/
        int direction;
        
        abstract void update() throws Exception;
        abstract void setMoved();
        abstract void setNotMoved();
        // setDir wird nur von Player bentigt, da sie aber aus einem MOB-Kontext aufgerufen wird, 
        // muss sie in MOB abstrakt implementiert sein.
        abstract void setDir(int dir);
    }
   
    /**
     * Die abgeleitete lokale Klasse Player erzeugt die Spielfigur und gibt ihr die 
     * Fhigkeit sich in der Spielwelt zu bewegen und ber den Ausgang zu gewinnen.
     */
    public class Player extends MOB{
        
        /** Der Konstruktor der lokalen Klasse Player erwartet eine x- und eine y-Koordinate
         *  und speichert sie ab. Auerdem setzt sie moved auf false womit es initialisiert wird.
         *  @param y ist die Position des Spieles in der y-Dimension.
         *  @param x ist die Position des Spieles in der x-Dimension.
         */
        Player(int y, int x){
            this.posX = x;
            this.posY = y;
            this.moved = false;
        }
        
        /** Die Methode setDir weist der Bewegungsrichtung einen neuen Wert zu.
         *  @param dir ist die Bewegungsrichtung nach der Aufschlsselung:
         *  0 = hoch
         *  1 = links
         *  2 = unten
         *  3 = rechts
         *  sonstige = stehen bleiben
         */
        void setDir(int dir){
            this.direction = dir;
        }
        
        /** Die Methode setMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf true, damit sie nicht noch einmal in diesem Zug bewegt wird.
         */
        void setMoved(){
            this.moved = true;
        }

        /** Die Methode setNotMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf false, damit sie im nchsten Zug wieder bewegt werden kann.
         */
        void setNotMoved(){
            this.moved = false;
        }
        
        /** Die Methode update lsst den Spieler seinen Zug machen und testet, ob er den Ausgang erreicht hat.*/
        void update() throws Exception{
            fieldChar[posY][posX] = ' ';
            int yBak = posY;
            int xBak = posX;
            move(direction);
            fieldMob[yBak][xBak] = null;
            if(fieldChar[posY][posX] == '!'){
                if(treasures == 1){
                    message = "Du hast alle Sch\u00e4tze eingesammelt.\nGehe nun zum Ausgang!";
                }
                treasures -= 1;
            }
            else if(fieldChar[posY][posX] == 'A'){
                if(treasures == 0){
                    message = "Du hast den Ausgang erreicht - gewonnen!";
                    print();
                    throw new Exception("Du hast den Ausgang erreicht - gewonnen!");
                }
                else{
                    posY = yBak;
                    posX = xBak;
                }

            }
            fieldChar[posY][posX] = 'S';
            fieldMob[posY][posX] = this;
        }
        
        /** Die Methode move erwartet eine Bewegungsrichtung nach o.g. Aufschlsselung
         *  und bewegt den Spieler entsprechend durch das Spielfeld.
         *  @param dir ist die Bewegungsrichtung, der der Spieler folgen soll.
         */
        void move(int dir) throws Exception{
            switch(dir){
                // Spieler luft hoch
                case 0: if(fieldChar[posY - 1][posX] != 'M' && fieldChar[posY - 1][posX] != 'U' && fieldChar[posY - 1][posX] != 'O'){
                            posY -= 1;
                        }
                        break;
                // Spieler luft nach links
                case 1: if(fieldChar[posY][posX - 1] != 'M' && fieldChar[posY][posX - 1] != 'U' && fieldChar[posY][posX - 1] != 'O'){
                            posX -= 1;
                        }
                        break;
                // Spieler luft runter
                case 2: if(fieldChar[posY + 1][posX] != 'M' && fieldChar[posY + 1][posX] != 'U' && fieldChar[posY + 1][posX] != 'O'){
                            posY += 1;
                        }
                        break;
                // Spieler luft nach rechts
                case 3: if(fieldChar[posY][posX + 1] != 'M' && fieldChar[posY][posX + 1] != 'U' && fieldChar[posY][posX + 1] != 'O'){
                            posX += 1;
                        }
                        break;
                // Spieler luft gar nicht        
                default: break;
            }
        }
    }
    
    /**
     * Die lokale Klasse Monster modelliert die Monster im Spiel mit ihren Fhigkeiten.
     */ 
    public class Monster extends MOB{
        
        /** Der Konstruktor der lokalen Klasse Monster erwartet eine x- und eine y-Koordinate
         *  und speichert sie ab und speichert sie ab. Auerdem setzt sie moved auf false
         *  womit es initialisiert wird.
         *  @param y ist die Position des Spieles in der y-Dimension.
         *  @param x ist die Position des Spieles in der x-Dimension.
         */
        Monster(int y, int x){
            this.posX = x;
            this.posY = y;
            this.moved = false;
            this.direction = (int) (Math.random()*4);
        }
        
        /** Da die Methode beim Monster nichts tun muss, bleibt sie Rumpflos. Sie muss aber implementiert werden.*/
        void setDir(int dir){}
        
        /** Die Methode setMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf true, damit sie nicht noch einmal in diesem Zug bewegt wird.
         */
        void setMoved(){
            this.moved = true;
        }

        /** Die Methode setNotMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf false, damit sie im nchsten Zug wieder bewegt werden kann.
         */
        void setNotMoved(){
            this.moved = false;
        }
                
        /** Die Methode update lsst das Monster seinen Zug machen und testet, ob es den Spieler gefressen hat.*/
        void update() throws Exception{
            fieldChar[posY][posX] = ' ';
            int yBak = posY;
            int xBak = posX;
            move(direction);
            fieldMob[yBak][xBak] = null;
            if(fieldChar[posY][posX] == 'S'){
                fieldChar[posY][posX] = 'X';
                print();
                throw new Exception("Das Monster hat dich erwischt - verloren! :(");
            }
            fieldChar[posY][posX] = 'U';
            fieldMob[posY][posX] = this;
        }
        
        /** Die Methode move erwartet eine Bewegungsrichtung nach o.g. Aufschlsselung
         *  und bewegt das Monster entsprechend durch das Spielfeld. Allerdings darf ein Monster nicht stehen bleiben.
         */        
        void move(int dir) throws Exception{
            switch(dir){
                case 0: if(fieldChar[posY-1][posX] != 'M' && fieldChar[posY-1][posX] != '!' && fieldChar[posY-1][posX] != 'O' && fieldChar[posY-1][posX] != 'A' && fieldChar[posY-1][posX] != 'E' && fieldChar[posY-1][posX] != 'U'){
                            posY -= 1;
                        }else if(fieldChar[posY][posX-1] != 'M' && fieldChar[posY][posX-1] != '!' && fieldChar[posY][posX-1] != 'O' && fieldChar[posY][posX-1] != 'A' && fieldChar[posY][posX-1] != 'E' && fieldChar[posY][posX-1] != 'U'){
                            this.direction = 1;
                        }else if(fieldChar[posY][posX+1] != 'M' && fieldChar[posY][posX+1] != '!' && fieldChar[posY][posX+1] != 'O' && fieldChar[posY][posX+1] != 'A' && fieldChar[posY][posX+1] != 'E' && fieldChar[posY][posX+1] != 'U'){
                            this.direction = 3;
                        }
                        else{
                            this.direction = 2;
                        }
                        break;
                
                case 1: if(fieldChar[posY][posX - 1] != 'M' && fieldChar[posY][posX - 1] != '!' && fieldChar[posY][posX - 1] != 'O' && fieldChar[posY][posX - 1] != 'A' && fieldChar[posY][posX - 1] != 'E' && fieldChar[posY][posX - 1] != 'U'){
                            posX -= 1;
                        }else if(fieldChar[posY+1][posX] != 'M' && fieldChar[posY+1][posX] != '!' && fieldChar[posY+1][posX] != 'O' && fieldChar[posY+1][posX] != 'A' && fieldChar[posY+1][posX] != 'E' && fieldChar[posY+1][posX] != 'U'){
                            this.direction = 2;
                        } else if(fieldChar[posY-1][posX] != 'M' && fieldChar[posY-1][posX] != '!' && fieldChar[posY-1][posX] != 'O' && fieldChar[posY-1][posX] != 'A' && fieldChar[posY-1][posX] != 'E' && fieldChar[posY-1][posX] != 'U'){
                            this.direction = 0;
                        } else {
                            this.direction = 3;
                        }
                        break;
                        
                case 2: if(fieldChar[posY + 1][posX] != 'M' && fieldChar[posY + 1][posX] != '!' && fieldChar[posY + 1][posX] != 'O' && fieldChar[posY + 1][posX] != 'A' && fieldChar[posY + 1][posX] != 'E' && fieldChar[posY + 1][posX] != 'U'){
                            posY += 1;
                        }else if(fieldChar[posY][posX+1] != 'M' && fieldChar[posY][posX+1] != '!' && fieldChar[posY][posX+1] != 'O' && fieldChar[posY][posX+1] != 'A' && fieldChar[posY][posX+1] != 'E' && fieldChar[posY][posX+1] != 'U'){
                            this.direction = 3;
                        }else if(fieldChar[posY][posX-1] != 'M' && fieldChar[posY][posX-1] != '!' && fieldChar[posY][posX-1] != 'O' && fieldChar[posY][posX-1] != 'A' && fieldChar[posY][posX-1] != 'E' && fieldChar[posY][posX-1] != 'U'){
                            this.direction = 1;
                        }else{
                            this.direction = 0;
                        }
                        break;

                case 3: if(fieldChar[posY][posX + 1] != 'M' && fieldChar[posY][posX + 1] != '!' && fieldChar[posY][posX + 1] != 'O' && fieldChar[posY][posX + 1] != 'A' && fieldChar[posY][posX + 1] != 'E' && fieldChar[posY][posX + 1] != 'U'){
                            posX += 1;
                        } else if(fieldChar[posY-1][posX] != 'M' && fieldChar[posY-1][posX] != '!' && fieldChar[posY-1][posX] != 'O' && fieldChar[posY-1][posX] != 'A' && fieldChar[posY-1][posX] != 'E' && fieldChar[posY-1][posX] != 'U'){
                            this.direction = 0;
                        }else if(fieldChar[posY+1][posX] != 'M' && fieldChar[posY+1][posX] != '!' && fieldChar[posY+1][posX] != 'O' && fieldChar[posY+1][posX] != 'A' && fieldChar[posY+1][posX] != 'E' && fieldChar[posY+1][posX] != 'U'){
                            this.direction = 2;
                        }else{
                            this.direction = 1;
                        }
                        break;
            }
        }
    }
    
    /**
     * Die Klasse Stone modelliert die Steine mit ihrer Fhigkeit
     * zu fallen, zu rollen und zu zermatschen.
     */
    public class Stone extends MOB{
        /** Der Konstruktor der lokalen Klasse Stone erwartet eine x- und eine y-Koordinate
         *  und speichert sie ab und speichert sie ab. Auerdem setzt sie moved auf false
         *  womit es initialisiert wird.
         *  @param y ist die Position des Spieles in der y-Dimension.
         *  @param x ist die Position des Spieles in der x-Dimension.
         */
        Stone(int y, int x){
            this.posX = x;
            this.posY = y;
            this.moved = false;
            this.direction = 4;
        }
        
        /** Da die Methode beim Monster nichts tun muss, bleibt sie Rumpflos. Sie muss aber implementiert werden.*/
        void setDir(int dir){}
        
        /** Die Methode setMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf true, damit sie nicht noch einmal in diesem Zug bewegt wird.
         */
        void setMoved(){
            this.moved = true;
        }

        /** Die Methode setNotMoved setzt das boolean, welches markiert, ob die Figut diesen Zug schon bewegt
         *  wurde auf false, damit sie im nchsten Zug wieder bewegt werden kann.
         */
        void setNotMoved(){
            this.moved = false;
        }
                
        /** Die Methode update lsst den Stein seinen Zug machen und testet, ob es den Spieler zermatscht hat.
         *  Die sonst obligatorische move-Methode wird hier gleich mit implementiert, da die Bewegungsrichtung
         *  eines Steins eher simpel ist. Runter oder abrutschen.
         */
        void update() throws Exception{
            // Unter dem Stein frei oder Spieler?
            if (fieldChar[posY+1][posX] == ' ' || (fieldChar[posY+1][posX] == 'U') || (fieldChar[posY+1][posX] == 'S' && direction == 2)){
                fieldChar[posY][posX] = ' ';
                posY += 1;
                smash(posY,posX);
                fieldChar[posY][posX] = 'O';
                fieldMob[posY][posX] = this;
                fieldMob[posY-1][posX] = null;
                direction = 2;
                print();
            }
            // Links unter dem Stein frei oder Spieler und unter dem Stein ein Stein?
            else if((fieldChar[posY][posX-1] == ' ' || fieldChar[posY][posX-1] == 'S') && fieldChar[posY+1][posX-1] == ' ' && fieldChar[posY][posX-1] == ' ' && fieldChar[posY+1][posX] == 'O'){ // || fieldChar[posY+1][posX-1] == 'S')
                fieldChar[posY][posX] = ' ';
                posY += 1;
                posX -= 1;
                smash(posY, posX);
                fieldChar[posY][posX] = 'O';
                fieldMob[posY][posX] = this;
                fieldMob[posY-1][posX+1] = null;
                direction = 2;
                update();
            }
            // Rechts unter dem Stein frei oder Spieler und unter dem Stein ein Stein?
            else if((fieldChar[posY][posX+1] == ' ' || fieldChar[posY][posX+1] == 'S') && fieldChar[posY+1][posX+1] == ' ' && fieldChar[posY][posX+1] == ' ' && fieldChar[posY+1][posX] == 'O'){ // || fieldChar[posY+1][posX-1] == 'S')
                fieldChar[posY][posX] = ' ';
                posY += 1;
                posX += 1;
                smash(posY, posX);
                fieldChar[posY][posX] = 'O';
                fieldMob[posY][posX] = this;
                fieldMob[posY-1][posX-1] = null;
                direction = 2;
                update();
            }
            // Bewegt sich der Stein nicht, bleibt er stehen und kann demnach danach ohne erneut zu fallen
            // keine Spieler zermatschen.
            else{
                direction = 4;
            }
        }
        
        /** Die Methode smash testet, ob der Stein beim fallen einen Spieler zermatscht hat.
         *  Dazu bentigt sie die Position des Steins.
         *  @param y ist die y-Koordinate im Spielfeld.
         *  @param x ist die x-Koordinate im Spielfeld.
         */
        void smash(int y, int x) throws Exception{
            if(fieldChar[y][x] == 'S'){
                fieldChar[y][x] = 'X';
                throw new Exception("Du wurdest von einem Stein erschlagen. Game Over.");
            }
        }
    }
}